#!/usr/local/bin/php -q
<?php
/**
 * $Horde: babel/bin/importall.php,v 1.2 2005/01/11 18:34:30 chuck Exp $
 * @copyright   2000, easyDNS Technologies Inc.
 */

ob_start();

$all_files = array();

echo 'Getting files ... ';
flush();

getAllFiles('all_files', false, true);

echo count($all_files) . " files found\n";

echo "Updating database ... \n";
flush();

$new = $updated = $deleted = $skipped = array();

foreach ($all_files as $file) {
    $path = str_replace('/Attic', '', $file['path'] );

    $query = sprintf("SELECT page_id, cvs_revision FROM pages WHERE path='%s' AND file='%s'",
                     $path,
                     $file['file']
    );

    $q = $DB->query($query);

    if ($q->numRows() == 0) {
        if (!$file['attic']) {
            printf("- adding %s/%s, revision %s\n",
                   $path,
                   $file['file'],
                   $file['cvs_revision']
            );

            $file['page_id'] = $DB->nextid('pages');
            unset($file['ext']);
            unset($file['attic']);
            $query = 'INSERT INTO pages ' . makeSQLInsert($file);
            $DB->query($query);

            $new[] = $file['page_id'];
        }
    } else {

        $r = $q->fetchrow();

        if ($file['attic']) {

            printf("- removing %s/%s\n",
                $path,
                $file['file']
            );
            $query = sprintf("DELETE FROM pages WHERE page_id=%d",
                $r['page_id']
            );

            $DB->query($query);
            $deleted[] = $r['page_id'];


        } else {

            if ($file['file']=='') {
                $cmp = 0;
            } else {
                $cmp = CVSLib_Rev::cmp($file['cvs_revision'], $r['cvs_revision']);
            }

            if ($cmp==0) {

                printf("- %s/%s is the same, skipping\n",
                    $path,
                    $file['file']
                );
                $skipped[] = $r['page_id'];

            } else {        /* $cmp should be 1, otherwise we've gone back a version */

                printf("- upgrading %s/%s from revision %s to %s\n",
                    $path,
                    $file['file'],
                    $r['cvs_revision'],
                    $file['cvs_revision']
                );
                $query = sprintf("UPDATE pages SET cvs_revision='%s' WHERE page_id=%d",
                    $file['cvs_revision'], $r['page_id']
                );

                $DB->query($query);
                $updated[] = $r['page_id'];
            }
        }
    }

    flush();
}

printf('Done: %d new files, %d updated, %d deleted',
       count($new),
       count($updated),
       count($deleted)
);

echo "\n";
ob_end_clean();
