<?php
/*
 * $Horde: babel/view.php,v 1.16 2005/01/03 14:34:48 jan Exp $
 *
 * Copyright 2002-2005 Jon Parise <jon@horde.org>
 * Copyright 2000, 2001 easyDNS Technologies Inc.
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

define('BABEL_BASE', dirname(__FILE__));
require_once BABEL_BASE . '/lib/base.php';

$where = $CVS->cvsRoot();
$title = 'i18n Repository';
$subhead = '[ <b>' . Horde::link(Babel::url('view')) . 'i18n</a></b> ] ';

if (isset($PATH_INFO)) {
	$where .= $PATH_INFO;
	$title = 'Directory of '.$PATH_INFO;
	$temp = explode('/', $PATH_INFO);
	$path = '';
	foreach ($temp as $part) {
		if ($part) {
			$path .= '/' . $part;
			$subhead.= ' / <b>' . Horde::link(Babel::url('view', $path)) . $part . '</a></b>';
		}
	}
}

require BABEL_TEMPLATES . '/common-header.inc';
require BABEL_TEMPLATES . '/page-header.inc';

$len = strlen($where)+2;

$query = "SELECT p.*, IF(p.file='',p.path,CONCAT(p.path,'/',p.file)) AS full, " .
	 "COUNT(s.string_id) AS strings " .
	 "FROM pages p LEFT JOIN strings s USING (page_id) " .
	 "WHERE path='$where' OR path LIKE '$where/%' " .
	 "GROUP BY p.page_id " .
	 "HAVING LOCATE('/', full, $len)=0 " .
	 'ORDER BY file, full';

$q = $DB->query($query);

$shown = 0;

require BABEL_TEMPLATES . '/view/header.inc';

$lang = @$_COOKIE['i18n_lang'];

while ($r = $q->fetchRow()) {

	$actions = array();

	$active = '';
	$strings = $r['strings'];
	$link = substr($r['full'], strlen($CVS->cvsRoot()));
	$file = substr($r['full'], strlen($where)+1);
	$needs_parsing = false;
	$strings = $current = 0;
	$force = 1;

	if ($r['file']=='') {
		$file = Horde::img('folder.png') . ' ' . $file;
		# don't show self
		if ($CVS->cvsRoot().$link == $where) {

			$link =  substr($link, 0, -strlen(strrchr($link,'/')) );
			$file = Horde::img('folder-back.png') . ' Previous Directory';
			$force = 0;

		} else {

			$file_rev = '';

			$query = sprintf("SELECT page_id, IF(p.db_revision=p.cvs_revision,0,1) AS needsparsing " .
				 "FROM pages p WHERE p.file!='' AND (p.path='%s' OR p.path LIKE '%s/%%')",
				$r['full'],
				$r['full']
			);

			$q2 = $DB->query($query);

			if ($q2->numrows()!=0) {

				$page_ids = array();
				while($r2 = $q2->fetchRow()) {
					$page_ids[] = $r2['page_id'];
					$needs_parsing += $r2['needsparsing'];
				}

				$query = sprintf("SELECT COUNT(string_id) AS count FROM strings WHERE page_id IN (%s)",
					join(',',$page_ids)
				);
				$q2 = $DB->query($query);
				$str_ids = array();
				$r2 = $q2->fetchRow();
				$strings = $r2['count'];

				if ($strings) {
					$query = sprintf("SELECT SUM(IF(t.db_revision=p.db_revision,1,0)) AS current " .
						"FROM translations t LEFT JOIN strings s USING (string_id) LEFT JOIN pages p USING (page_id) " .
						"WHERE s.page_id IN (%s) AND t.lang='%s'",
						join(',',$page_ids),
						$lang
					);
					$q2 = $DB->query($query);
					$r2 = $q2->fetchRow();
					$current = $r2['current'];
				}
			}
		}

		$show = Horde::link(Babel::url('view', $link)) . $file . '</a>';

	} else {

		$file = Horde::img('text.png') . ' ' . $file;
		$strings = $r['strings'];

		if ($strings) {
			$show = Horde::link(Babel::url('strings', $link)) . $file . '</a>';
			$actions[] = Horde::link(Babel::url('strings', $link)) . Horde::img('edit.png','edit') . '</a>';

			$query = sprintf("SELECT SUM(IF(t.db_revision=p.db_revision,1,0)) AS current " .
				"FROM translations t LEFT JOIN strings s USING (string_id) LEFT JOIN pages p USING (page_id) " .
				"WHERE s.page_id=%d AND t.lang='%s'",
				$r['page_id'],
				$lang
			);
			$q2 = $DB->query($query);
			$r2 = $q2->fetchRow();
			$current = $r2['current'];
		} else {
			$show = $file;
			$active = '_inactive';
		}
		if (CVSLib_Rev::cmp($r['db_revision'], $r['cvs_revision']) ) {
			$needs_parsing = true;
		}
	}

	if ($needs_parsing) {
		$actions[] = Horde::link(Babel::url('reparse', $link)) . Horde::img('reload.png', 'reparse', '', $registry->getImageDir('horde')) . '</a>';
	} elseif ($USER->builder && $force) {
		$actions[] = Horde::link(Babel::url('reparse', $link)) . Horde::img('force.png', 'force') . '</a>';
	}

    include BABEL_TEMPLATES . '/view/row.inc';

	$shown++;
}

require BABEL_TEMPLATES . '/view/footer.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
